package com.example.demo_OptionalFields;

import org.springframework.data.rest.core.config.Projection;

import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.GeneratedValue;
import jakarta.persistence.Id;
import jakarta.persistence.Table;
import lombok.Data;
import lombok.NoArgsConstructor;

@Data
@Entity
@Table(name = "T_DEMOTABLE")
@NoArgsConstructor
public class OptionalFieldsEntity {

	@Id
	@GeneratedValue
	private Long id;

	@Column(name = "T_NAME", nullable = false)
	private String name;

	@Column(name = "T_USED_NAME", nullable = true)
	private String usedName;
	
	@Projection(name = "idName", types = { OptionalFieldsEntity.class })
	public interface IdName {
		Long getId();
		String getName();
	}

	@Projection(name = "Names", types = { OptionalFieldsEntity.class })
	public interface Names {
		String getName();
		String getUsedName();
	}

}
